1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 if [ $MSGLEVEL -le 3 ]; then
47 if [ $MSGLEVEL -le 4 ]; then
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
59 echo "${CDONE}DONE${CNORMAL}" >&2;
64 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f .
/aptconfig.conf
]; then
66 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
67 elif [ -f ..
/aptconfig.conf
]; then
68 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
70 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
73 aptconfig
() { runapt apt
-config $
*; }
74 aptcache
() { runapt apt
-cache $
*; }
75 aptget
() { runapt apt
-get $
*; }
76 aptftparchive
() { runapt apt
-ftparchive $
*; }
77 aptkey
() { runapt apt
-key $
*; }
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
83 TMPWORKINGDIRECTORY
=$(mktemp -d)
84 local TESTDIR
=$(readlink -f $(dirname $0))
85 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
86 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
87 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
88 local OLDWORKINGDIRECTORY
=$(pwd)
89 CURRENTTRAP
="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
90 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
91 cd $TMPWORKINGDIRECTORY
92 mkdir rootdir aptarchive keys
94 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
95 mkdir -p var
/cache var
/lib var
/log
96 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
97 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
98 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
99 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
101 touch var/lib/dpkg/status
103 touch var/lib/dpkg/available
105 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
107 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
108 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
109 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
111 touch aptarchive
/Packages
113 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys
/
114 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
115 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
116 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
117 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
118 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
119 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
120 echo "Dir::Bin::methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
121 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
122 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
123 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
124 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
125 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
130 configarchitecture
() {
131 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
132 echo "APT::Architecture \"$1\";" > $CONFFILE
134 while [ -n "$1" ]; do
135 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
140 setupsimplenativepackage
() {
144 local RELEASE
="${4:-unstable}"
145 local DEPENDENCIES
="$5"
146 local DESCRIPTION
="$6"
147 local SECTION
="${7:-others}"
149 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
152 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
154 local BUILDDIR
=incoming
/${NAME}-${VERSION}
155 mkdir -p ${BUILDDIR}/debian
/source
157 echo "* most suckless software product ever" > FEATURES
158 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
159 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
163 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
164 test -e debian
/control
|| echo "Source: $NAME
167 Maintainer: Joe Sixpack <joe@example.org>
168 Build-Depends: debhelper (>= 7)
169 Standards-Version: 3.9.1
172 Architecture: $ARCH" > debian
/control
173 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
174 if [ -z "$DESCRIPTION" ]; then
175 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
176 If you find such a package installed on your system,
177 YOU did something horribly wrong! They are autogenerated
178 und used only by testcases for APT and surf no other propose…" >> debian
/control
180 echo "Description: $DESCRIPTION" >> debian
/control
182 test -e debian
/compat
|| echo "7" > debian
/compat
183 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
184 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
188 buildsimplenativepackage
() {
192 local RELEASE
="${4:-unstable}"
193 local DEPENDENCIES
="$5"
194 local DESCRIPTION
="$6"
195 local SECTION
="${7:-others}"
197 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
200 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
202 setupsimplenativepackage
"$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
203 buildpackage
"incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
204 rm -rf "incoming/${NAME}-${VERSION}"
211 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
213 if [ "$ARCH" = "all" ]; then
214 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
216 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
217 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
218 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
221 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
224 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
230 if [ -d incoming
]; then
231 buildaptarchivefromincoming $
*
233 buildaptarchivefromfiles $
*
237 createaptftparchiveconfig
() {
238 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
239 if [ -z "$ARCHS" ]; then
240 # the pool is empty, so we will operate on faked packages - let us use the configured archs
241 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
244 ArchiveDir "' >> ftparchive.conf
245 echo -n $(readlink -f .) >> ftparchive.conf
247 CacheDir "' >> ftparchive.conf
248 echo -n $(readlink -f ..) >> ftparchive.conf
250 FileListDir "' >> ftparchive.conf
251 echo -n $(readlink -f pool/) >> ftparchive.conf
255 Packages::Compress ". gzip bzip2 lzma";
256 Sources::Compress ". gzip bzip2 lzma";
257 Contents::Compress ". gzip bzip2 lzma";
261 SrcDirectory "pool/";
267 Label "apttestcases";
269 Description "repository with dummy packages";
270 Architectures "' >> ftparchive.conf
271 echo -n "$ARCHS" >> ftparchive.conf
275 };' >> ftparchive.conf
276 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
277 echo -n 'tree "dists/' >> ftparchive.conf
278 echo -n "$DIST" >> ftparchive.conf
280 Architectures "' >> ftparchive.conf
281 echo -n "$ARCHS" >> ftparchive.conf
283 FileList "' >> ftparchive.conf
284 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
286 SourceFileList "' >> ftparchive.conf
287 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
289 Sections "' >> ftparchive.conf
290 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
292 };' >> ftparchive.conf
296 buildaptftparchivedirectorystructure
() {
297 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
298 for DIST
in $DISTS; do
299 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
300 for SECTION
in $SECTIONS; do
301 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
302 for ARCH
in $ARCHS; do
303 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
305 mkdir -p dists
/${DIST}/${SECTION}/source
306 mkdir -p dists
/${DIST}/${SECTION}/i18n
311 buildaptarchivefromincoming
() {
312 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
314 [ -e pool
] || ln -s ..
/incoming pool
315 [ -e ftparchive.conf
] || createaptftparchiveconfig
316 [ -e dists
] || buildaptftparchivedirectorystructure
317 msgninfo
"\tGenerate Packages, Sources and Contents files… "
318 aptftparchive
-qq generate ftparchive.conf
320 msgninfo
"\tGenerate Release files… "
321 for dir
in $(find ./dists -mindepth 1 -maxdepth 1 -type d); do
322 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Codename
="$(echo "$dir" | cut -d'/' -f 3)" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
328 buildaptarchivefromfiles
() {
329 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
331 if [ -f Packages
]; then
332 msgninfo
"\tPackages file… "
333 cat Packages
| gzip > Packages.gz
334 cat Packages
| bzip2 > Packages.bz2
335 cat Packages
| lzma
> Packages.lzma
338 if [ -f Sources
]; then
339 msgninfo
"\tSources file… "
340 cat Sources
| gzip > Sources.gz
341 cat Sources
| bzip2 > Sources.bz2
342 cat Sources
| lzma
> Sources.lzma
345 msgninfo
"\tRelease file… "
346 aptftparchive
-qq release .
| sed -e '/0 Release$/ d' > Release
# remove the self reference
351 setupdistsaptarchive
() {
352 local APTARCHIVE
=$(readlink -f ./aptarchive)
353 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
354 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
355 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
356 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
357 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
358 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
359 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
364 setupflataptarchive
() {
365 local APTARCHIVE
=$(readlink -f ./aptarchive)
366 if [ -f ${APTARCHIVE}/Packages
]; then
367 msgninfo
"\tadd deb sources.list line… "
368 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
371 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
373 if [ -f ${APTARCHIVE}/Sources
]; then
374 msgninfo
"\tadd deb-src sources.list line… "
375 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
378 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
384 if [ -e aptarchive
/dists
]; then
390 msgninfo
"\tSync APT's cache with the archive… "
396 local SIGNER
="${1:-Joe Sixpack}"
397 msgninfo
"\tSign archive with $SIGNER key… "
399 for KEY
in $(find keys/ -name '*.sec'); do
400 SECKEYS
="$SECKEYS --secret-keyring $KEY"
403 for KEY
in $(find keys/ -name '*.pub'); do
404 PUBKEYS
="$PUBKEYS --keyring $KEY"
406 for RELEASE
in $(find aptarchive/ -name Release); do
407 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
412 changetowebserver
() {
413 if which weborf
> /dev
/null
; then
414 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
415 CURRENTTRAP
="kill $(ps | grep weborf | sed -e 's#^[ ]*##' | cut -d' ' -f 1); $CURRENTTRAP"
416 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
417 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
418 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
419 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
427 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
428 if [ -n "$DIFFTEXT" ]; then
440 msgtest
"Test for correctness of file" "$FILE"
442 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
444 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
449 local COMPAREFILE
=$(mktemp)
450 echo "$1" > $COMPAREFILE
452 msgtest
"Test for equality of" "$*"
453 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
458 local COMPAREFILE1
=$(mktemp)
459 local COMPAREFILE2
=$(mktemp)
460 local COMPAREAGAINST
=$(mktemp)
461 echo "$1" > $COMPAREFILE1
462 echo "$2" > $COMPAREFILE2
464 msgtest
"Test for equality OR of" "$*"
465 $
* 2>&1 1> $COMPAREAGAINST
466 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
467 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
468 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
469 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
471 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
475 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
478 while [ -n "$1" ]; do
480 N: Can't select versions from package '$1' as it purely virtual"
481 PACKAGE
="${PACKAGE} $1"
484 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
486 N: No packages found"
487 local COMPAREFILE
=$(mktemp)
488 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
489 eval `apt-config shell ARCH APT::Architecture`
490 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
491 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
496 msgtest
"Test for non-existent packages" "apt-cache show $*"
497 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
498 if [ -n "$SHOWPKG" ]; then
507 testdpkginstalled
() {
508 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
509 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
510 if [ "$PKGS" != 0 ]; then
512 dpkg
-l $
* | grep '^[a-z]'
519 testdpkgnoninstalled
() {
520 msgtest
"Test for correctly non-installed package(s) with" "dpkg -l $*"
521 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
522 if [ "$PKGS" != 0 ]; then
524 dpkg
-l $
* | grep '^[a-z]'